=begin
------------------------------------------------------------------------
Copyright 2007, TIG (c)
Permission to use, copy, modify, and distribute this software for any 
purpose, and currently without fee, is hereby granted, provided that  
this text and the above copyright (c) notice appear in all copies.
This software is provided "as is" and without any express or implied 
warranties, including, without limitation, the implied warranties of 
merchantability and fitness for a particular purpose.
------------------------------------------------------------------------
Name        : Roof.rb
Author      : TIG
Description : A set of Roof Making Tools.
Menu Item   : Plugins > Roof... > Sub-Menus...
Usage       : See RoofHelp.mht file originally distributed with this.
Version     : 1.0	20070824	First issue.
			  1.1	20070826	A:B slope glitch fixed: array.to_f !
------------------------------------------------------------------------
=end
eval %q{PWJlZ2luCi0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0tLS0t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}.unpack("m").to_s